# Zombie spawning
execute as @e[type=#apocalypse:zombie_replaceable,tag=!zombie,sort=random] at @s if predicate apocalypse:overworld run function apocalypse:spawn/zombie/spawn_zombie

execute as @e[type=drowned,tag=!zombie,sort=random] at @s run function apocalypse:spawn/drowned/spawn_drowned_conversion
execute as @e[type=#apocalypse:drowned_replaceable,tag=!zombie,sort=random] at @s run function apocalypse:spawn/drowned/spawn_drowned_natural

execute unless score animal_toggle animal_toggle matches 1 run execute as @e[type=chicken,tag=!zombie,sort=random] at @s run function apocalypse:spawn/animal/spawn_chicken
execute unless score animal_toggle animal_toggle matches 1 run execute as @e[type=pig,tag=!zombie,sort=random] at @s run function apocalypse:spawn/animal/spawn_pig
execute unless score animal_toggle animal_toggle matches 1 run execute as @e[type=sheep,tag=!zombie,sort=random] at @s run function apocalypse:spawn/animal/spawn_sheep
execute unless score animal_toggle animal_toggle matches 1 run execute as @e[type=cow,tag=!zombie,sort=random] at @s run function apocalypse:spawn/animal/spawn_cow
execute unless score animal_toggle animal_toggle matches 1 run execute as @e[type=horse,tag=!zombie,sort=random] at @s run function apocalypse:spawn/animal/spawn_horse

### ZOMBIE ABILITY FUNCTIONALITY
#Ability Timer
execute if score ability_timer ability_timer matches ..0 run scoreboard players set ability_timer ability_timer 80
execute unless score ability_timer ability_timer matches ..0 run scoreboard players remove ability_timer ability_timer 1

scoreboard players remove @e[type=#apocalypse:is_zombie,scores={ability_timer=1..}] ability_timer 1
scoreboard players set @e[type=zombie,tag=acid_spitter,scores={ability_timer=0}] ability_timer 60
scoreboard players set @e[type=zombie,tag=acid_spewer,scores={ability_timer=0}] ability_timer 25
scoreboard players set @e[type=zombie,tag=modifier,scores={ability_timer=0}] ability_timer 60
scoreboard players set @e[type=drowned,tag=water,scores={ability_timer=0}] ability_timer 80

#Builder and Miner Functionality
execute as @e[type=zombie,tag=modifier,scores={ability_timer=2}] at @s if entity @p[distance=..36] run function apocalypse:zombie_abilities/get_direction

#Nurse Zombie Functionality
execute as @e[type=zombie,tag=nurse] at @s if score ability_timer ability_timer matches 2 if entity @p[distance=..26] run function apocalypse:zombie_abilities/nurse/nurse

#Acid Spitter Functionality
execute as @e[type=zombie,tag=acid_spitter,scores={ability_timer=2}] at @s anchored eyes facing entity @p[distance=..7,gamemode=!creative] feet if entity @p[distance=..7,gamemode=!creative] run function apocalypse:zombie_abilities/acid_spitter/shoot
execute as @e[type=zombie,tag=acid_spitter] at @s if entity @p[distance=..7,gamemode=!creative] run effect give @s slowness 1 4 true

#Acid Spewer Functionality
execute as @e[type=zombie,tag=acid_spewer,scores={ability_timer=2}] at @s anchored eyes facing entity @p[distance=..4,gamemode=!creative] feet if entity @p[distance=..4,gamemode=!creative] run function apocalypse:zombie_abilities/acid_spewer/shoot
execute as @e[type=zombie,tag=acid_spewer] at @s if entity @p[distance=..4,gamemode=!creative] run effect give @s slowness 1 2 true

#Water Spitter Functionality
execute as @e[type=drowned,tag=water] at @s anchored eyes facing entity @p[distance=..4,gamemode=!creative] feet if score @s ability_timer matches 2 if entity @p[distance=..7,gamemode=!creative] run function apocalypse:zombie_abilities/water/shoot

#Animal Zombie Functionality
execute as @e[type=husk] at @s run function apocalypse:zombie_abilities/kill_brain

#Water Zombie Functionality
execute as @e[type=drowned,tag=water_zombie,limit=20,sort=random] at @s if block ~ ~ ~ #apocalypse:water run attribute @s generic.movement_speed base set 0.85
execute as @e[type=drowned,tag=water_zombie,limit=20,sort=random] at @s unless block ~ ~ ~ #apocalypse:water run attribute @s generic.movement_speed base set 0.3

#Player Zombie Functionality
execute as @a[scores={player_death=1..}] at @s run function apocalypse:spawn/player_zombie

#Zombie Extra Damage on Fire
execute as @e[type=zombie,predicate=apocalypse:is_burning,tag=!scorched] at @s run function apocalypse:zombie_on_fire


## Illager Skirmisher Spawning
execute if score gbz.illager_spawner gbz.illager_spawner matches 0 store result score gbz.day_time gbz.day_time run time query daytime
execute if score gbz.illager_spawner gbz.illager_spawner matches 0 if score gbz.day_time gbz.day_time matches 13700..22600 store result score gbz.illager_spawner gbz.illager_spawner run random value 5050..7200
execute if score gbz.illager_spawner gbz.illager_spawner matches 0 as @a[sort=random,limit=1] at @s run function apocalypse:spawn/skirmisher/spawn1
execute if score gbz.illager_spawner gbz.illager_spawner matches ..0 store result score gbz.illager_spawner gbz.illager_spawner run random value 72000..144000
scoreboard players remove gbz.illager_spawner gbz.illager_spawner 1





